<?php
/*
Plugin Name: Ozh's IP To Nation
Plugin URI: http://planetozh.com/blog/archives/2004/08/27/ip-to-nation-plugin/
Description: Retrieves and caches the country name of the visitor, guessed from is IP. Uses <a href="http://www.ip2nation.com/">ip2nation</a>'s data.
Version: 1.2.1.1
Author: Ozh
Author URI: http://planetozh.com/
*/

/* Version history
   1.0 : initial release
   1.1 : can't remember :P
   1.2.1 : implemented a fast caching solution. Reduces the number of queries.
   1.2.1.1 : better way of creating cache dir
*/

$wp_ozh_ip2nation['cache'] = substr(str_replace('\\','/',__FILE__),0,strpos(str_replace('\\','/',__FILE__),'/wp-content/plugins/')).'/wp-content/cache/ip2nation';
	// directory, or empty string not to cache
	// Examples :
	// 		e:/www/wordpress/wp-content/cache/ip2nation
	// 		/home/joe/wordpress/somedir
	// 		substr(str_replace('\\','/',__FILE__),0,strpos(str_replace('\\','/',__FILE__),'/wp-content/plugins/')).'/wp-content/cache/ip2nation'
	//		Note: this last expression will simply guess the correct location with normal WP installs (recommended)
	
/*******************************/

if (!is_dir($wp_ozh_ip2nation['cache'])) wp_mkdir_p($wp_ozh_ip2nation['cache']);

$wp_ozh_ip2nation['results'] = array();
$wp_ozh_ip2nation['cachehits'] = 0;

function wp_ozh_ip2nation ($ip) {
	global $wpdb, $wp_ozh_ip2nation;
	
	if ($wp_ozh_ip2nation['cache']) {
		$cached = $wp_ozh_ip2nation['cache'].'/'.md5($ip);
		if (file_exists($cached)) {
			$wp_ozh_ip2nation['cachehits']++;
			return unserialize(file_get_contents($cached));
		}
	}
	
	$sql = "SELECT
		 c.country,
		 c.code
	  FROM
		 ip2nationCountries c,
		 ip2nation i
	  WHERE
		 i.ip < INET_ATON('".$ip."')
	  AND
		 c.code = i.country
	  ORDER BY
		 i.ip DESC
	  LIMIT 0,1";
	$row = $wpdb->get_row("$sql");
	
	if ($wp_ozh_ip2nation['cache']) {
		$handle = @fopen($cached, "w"); 
		fwrite($handle, serialize($row)); 
		fclose($handle);
	}
	return $row;
}

function wp_ozh_getCountryName ($display=0,$ip="") {
	global $wpdb, $wp_ozh_ip2nation;
	
	if (!$ip)
		$ip = $_SERVER['REMOTE_ADDR'];
	
	if (!array_key_exists($ip,$wp_ozh_ip2nation['results']))
		$wp_ozh_ip2nation['results'][$ip] = wp_ozh_ip2nation($ip);
		
	if ($display)
		echo $wp_ozh_ip2nation['results'][$ip]->country;

	return $wp_ozh_ip2nation['results'][$ip]->country;
}

function wp_ozh_getCountryCode ($display=0,$ip="") {
	global $wpdb, $wp_ozh_ip2nation;
	
	if (!$ip)
		$ip = $_SERVER['REMOTE_ADDR'];
	
	if (!array_key_exists($ip,$wp_ozh_ip2nation['results']))
		$wp_ozh_ip2nation['results'][$ip] = wp_ozh_ip2nation($ip);
		
	if ($display)
		echo $wp_ozh_ip2nation['results'][$ip]->code;

	return $wp_ozh_ip2nation['results'][$ip]->code;
}

/**
* SAMPLE USAGE :
* echo "You are probably from ". wp_ozh_getCountryName() ."<br />";
* echo "If so, your country flag is <img src=\"http://yourblog.com/images/flag_" . wp_ozh_getCountryCode() . ".gif\"><br />";
*
* More examples here : http://planetozh.com/blog/archives/2004/08/27/ip-to-nation-plugin/
*
*/

?>
